100 REMark **********************************************
110 REMark                ADVENTURE SHELL
120 REMark **********************************************
130 REMark                by Tim Hartnell
140 REMark             Interface publications
150 REMark **********************************************
160 REMark       Converted to QL BASIC and enhanced
170 REMark             by David Denham, 2017
180 REMark **********************************************
190 REMark v1.0 (QL)
200 :
210 REMark **********************************************
220 REMark *            SET DISPLAY WINDOWS             *
230 REMark **********************************************
240 WINDOW #0,512,256,0,0
250 BORDER #0,1,255
260 PAPER #0,0 : INK #0,7 : CLS #0
270 :
280 RANDOMISE  : REMark ** BEST RANDOM NUMBERS WE CAN GET
290 :
300 REMark **********************************************
310 REMark * SET VARIABLES, MAP, MONSTERS, TREASURE ETC *
320 REMark **********************************************
330 INITIALISE : REMark ** SET VARIABLES ETC
340 :
350 REMark **********************************************
360 REMark * SHOW GAME TITLE AND ANY INTRODUCTORY TEXT  *
370 REMark **********************************************
380 INK #0,4 : UNDER #0,1 : PRINT #0,TITLE$ : UNDER #0,0 : INK #0,7
390 SHOW_INTRODUCTORY_TEXT
400 :
410 REPeat GAME
420   REMark *********************************************
430   REMark * HAVE WE REACHED THE HIGHEST ROOM NUMBER?  *
440   REMark * IF SO, REPORT SUCCESSFUL COMPLETION       *
450   REMark *********************************************
460   IF ROOM = NO_OF_ROOMS THEN
470     QUIT_FLAG = 1 : REMark SUCCESFUL COMPLETION FLAG
480     EXIT GAME
490   END IF
500   :
510   REMark ********************************************
520   REMark *      DISPLAY THE ROOM DESCRIPTIONS       *
530   REMark ********************************************
540   DISPLAY_ROOM_DESCRIPTION ROOM,0
550   :
560   REMark ********************************************
570   REMark * NEXT LINE ACTIVATED IF OBJECT(S) IN ROOM *
580   REMark ********************************************
590   IF MAP(ROOM,5) + MAP(ROOM,6) + MAP(ROOM,7) > 0 THEN DESCRIBE_OBJECTS_IN_ROOM
600   :
610   IF RND > .5 THEN
620     MOVE_MONSTER 6 : REMark ** THE DILWYN
630   ELSE
640     MOVE_MONSTER 7 : REMark ** RED DRAGON
650   END IF
660   :
670   REMark ********************************************
680   REMark * NEXT LINES ACTIVATED IF MONSTER IN ROOM  *
690   REMark *  THE MONSTER MAY ATTACK YOU AT RANDOM!   *
700   REMark ********************************************
710   IF MAP(ROOM,8) > 0 THEN
720     REMark ** >0 means there IS a monster in the room
730     RAN = RND(1 TO 3)
740     SELect ON RAN
750       =1 : PRINT #0,"** LOOK OUT!";
760       =2 : PRINT #0,"** BE CAREFUL!";
770       =3 : PRINT #0,"** OH OH!";
780     END SELect
790     PRINT #0," There is a";
800     IF MONSTER$(MAP(ROOM,8),1) INSTR "AEIOU" THEN PRINT #0,"n";
810     PRINT #0," ";MONSTER$(MAP(ROOM,8));" here!"
820     IF MONSTER$(MAP(ROOM,8)) == "vanpeebles" THEN
830       IF RND > .5 THEN
840         INK #0,2
850         IF RND > .5 THEN
860           PRINT #0,"PARP!"
870         ELSE
880           PRINT #0,"The vanpeebles parps at you!"
890         END IF
900         INK #0,7
910       END IF
920     END IF
930     IF RND > .7 THEN
940       REMark ** 30% chance the monster might attack you in the room
950       PRINT #0,"The ";MONSTER$(MAP(ROOM,8));
960       RAN = RND(1 TO 3)
970       SELect ON RAN
980         =1 : PRINT #0," goes for you!"
990         =2 : PRINT #0," attacks!"
1000         =3 : PRINT #0," pounces on you!"
1010       END SELect
1020       KW = 1
1030       FIGHT_ROUTINE
1040       NEXT GAME
1050     ELSE
1060       REMark ** MONSTER DOES NOT ATTACK,SO RANDOMLY
1070       REMark ** PRINT A MESSAGE TO THAT EFFECT.
1080       IF RND > .3 THEN
1090         IF RND > .5 THEN PRINT #0,"Fortunately, t"; : ELSE PRINT #0,"T";
1100         PRINT #0,"he ";MONSTER$(MAP(ROOM,8));" ";
1110         RAN = RND(1 TO 3)
1120         SELect ON RAN
1130           =1 : PRINT #0,"does not notice you."
1140           =2 : PRINT #0,"ignores you."
1150           =3 : PRINT #0,"is asleep."
1160         END SELect
1170       END IF
1180     END IF
1190   ELSE
1200     IF MAP(ROOM,8) < 0 THEN
1210       REMark ** MONSTER REAPPEARS AFTER BRIEF NAP FOLLOWING FIGHT
1220       IF RND > .5 THEN MAP(ROOM,8) = ABS(ROOM,8)
1230     END IF
1240   END IF
1250   :
1260   REMark ********************************************
1270   REMark *     NEXT LINES DECREMENT ATTRIBUTES      *
1280   REMark *     AND REPORT ATTRIBUTES TO PLAYER      *
1290   REMark ********************************************
1300   IF RND > .94 THEN H_STRE = H_STRE - 1 : IF H_STRE < 0 THEN H_STRE = 0 : REMark STRENGTH
1310   IF RND > .94 THEN H_CHAR = H_CHAR - 1 : IF H_CHAR < 0 THEN H_CHAR = 0 : REMark CHARISMA
1320   IF RND > .94 THEN H_DEXT = H_DEXT - 1 : IF H_DEXT < 0 THEN H_DEXT = 0 : REMark DEXTERITY
1330   IF RND > .94 THEN H_INTE = H_INTE - 1 : IF H_INTE < 0 THEN H_INTE = 0 : REMark INTELLIGENCE
1340   IF RND > .94 THEN H_WISD = H_WISD - 1 : IF H_WISD < 0 THEN H_WISD = 0 : REMark WISDOM
1350   IF RND > .94 THEN H_CONS = H_CONS - 1 : IF H_CONS < 0 THEN H_CONS = 0 : REMark CONSTITUTION
1360   :
1370   PRINT #0,"Your attributes are : Strength    : ";H_STRE TO 40;"Charisma: ";H_CHAR TO 54;"Dexterity   : ";H_DEXT
1380   PRINT #0,"                      Intelligence: ";H_INTE TO 40;"Wisdom  : ";H_WISD TO 54;"Constitution: ";H_CONS
1390   :
1400   REMark ********************************************
1410   REMark *  NEXT LINE CHECKS IF ANY ATTRIBUTE IS 0  *
1420   REMark *   IN WHICH CASE YOU HAVE LOST THE GAME   *
1430   REMark ********************************************
1440   IF H_STRE * H_CHAR * H_DEXT * H_CONS * H_INTE * H_WISD = 0 THEN
1450     REMark ** YOU ARE EXHAUSTED,SO GAME ENDS
1460     QUIT_FLAG = 2 : REMark QUIT FLAG - 2=EXHAUSTED
1470     EXIT GAME
1480   END IF
1490   :
1500   REMark ********************************************
1510   REMark * SHOW LIST OFITEMS CARRIED PLUS THE VALUE *
1520   REMark ********************************************
1530   INVENTORY
1540   :
1550   REMark ********************************************
1560   REMark *  PARSER - NEXT LINES ACCEPT PLAYER INPUT *
1570   REMark ********************************************
1580   KW = 0 : REMark ** KEYWORD - EQUALS 1 IF UNDERSTOOD
1590   REPeat ENTER
1600     INPUT #0,\"What do you want to do ? ";USER_INPUT$
1610     USER_INPUT$ = TL$(USER_INPUT$) : REMark STRIP LEFT SPACES
1620     IF USER_INPUT$ <> "" THEN EXIT ENTER
1630     REMark BLANK INPUT
1640     IF RND > .5 THEN PRINT #0,"Huh?" : ELSE PRINT #0,"Eh?" : END IF
1650   END REPeat ENTER
1660   :
1670   SPACE = " " INSTR USER_INPUT$ : REMark BREAK UP BOTH WORDS
1680   IF SPACE = 0 THEN
1690     WORD1$ = USER_INPUT$ : WORD2$ = "" : REMark ONE WORD ONLY
1700   ELSE
1710     WORD1$ = USER_INPUT$(1 TO SPACE-1)                   : REMark FIRST WORD
1720     WORD2$ = TL$(USER_INPUT$(SPACE TO LEN(USER_INPUT$))) : REMark SECOND WORD/PHRASE IF GIVEN
1730   END IF
1740   :
1750   REMark ***********************************************************
1760   REMark *  TEST PARSER BY PRINTING BOTH WORDS IN < > BRACKETS     *
1770   REMark *  REMOVE THE REM STATEMENTS TO TEST PARSER               *
1780   REMark ***********************************************************
1790   REMark PRINT #0,"WORD 1:<";WORD1$;">"
1800   REMark PRINT #0,"WORD 2:<";WORD2$;">"
1810   REMark ***********************************************************
1820   :
1830   IF WORD2$ = "" THEN
1840     REMark *********************************************************
1850     REMark *    SINGLE WORD COMMANDS SUCH AS "HELP" AND "QUIT"     *
1860     REMark *********************************************************
1870     :
1880     IF WORD1$ == "HELP" THEN
1890       REMark ** HELP COMMAND - amend if you wish to provide HELP
1900       PRINT "You must be joking!"
1910       KW = 1
1920     END IF
1930     :
1940     IF WORD1$ == "QUIT" THEN
1950       REMark ** QUIT COMMAND
1960       KW = 1 : QUIT_FLAG = 4 : REMark QUIT MODE FLAG
1970       EXIT GAME : REMark PRINT CLOSING SUMMARY
1980     END IF
1990     :
2000     IF WORD1$ == "VOCAB" OR WORD1$ == "VOCABULARY" THEN
2010       REMark ** VOCABULARY COMMAND - EDIT THE LIST IN PROC "VOCABULARY"
2020       KW = 1 : VOCABULARY
2030     END IF
2040     :
2050     IF WORD1$ == "MAP" THEN
2060       REMark ** MAP COMMAND - EDIT THE PROCEDURE "SHOW_MAP" TO SUIT
2070       KW = 1 : SHOW_MAP
2080     END IF
2090     :
2100     REMark *********************************************************
2110     REMark *  ADD ANY FURTHER SINGLE WORD COMMANDS HERE,USING THE  *
2120     REMark *  EXAMPLES ABOVE.                                      *
2130     REMark *********************************************************
2140     :
2150   ELSE
2160     REMark *********************************************************
2170     REMark *  TWO WORD VERB / NOUN COMMANDS ARE INTERPRETED HERE.  *
2180     REMark *********************************************************
2190     :
2200     REMark *********************************************************
2210     REMark *  NEXT LINES 'UNDERSTAND' USER INPUT.                  *
2220     REMark *  IF YOU PREFER,  CHANGE TO JUST TESTING FIRST 2 OR 3  *
2230     REMark *  LETTERS OF A WORD TO ALLOW ABBREVIATION OF COMMANDS  *
2240     REMark *  E.G. KI INSTEAD OF 'KILL', G INSTEAD OF 'GO'         *
2250     REMark *********************************************************
2260     :
2270     REMark ** NEXT LINE ACCEPTS 'KILL' OR 'FIGHT' OR 'ATTACK' OR 'SLAY'
2280     IF WORD1$ == "KILL" OR WORD1$ == "FIGHT" OR WORD1$ == "ATTACK" OR WORD1$ == "SLAY" THEN
2290       KW = 1 : FIGHT_ROUTINE
2300     END IF
2310     :
2320     REMark ** NEXT LINE ACCEPTS 'RUN' OR 'GO' OR 'MOVE'
2330     IF WORD1$ == "GO" OR WORD1$ == "MOVE" OR WORD1$ == "RUN" OR WORD1$ == "WALK" THEN
2340       KW = 1 : MOVEMENT_ROUTINE
2350     END IF
2360     :
2370     REMark ** NEXT LINE ACCEPTS 'GET' OR 'TAKE' OR 'LIFT' OR 'GRAB'
2380     IF WORD1$ == "GET" OR WORD1$ == "TAKE" OR WORD1$ == "LIFT" OR WORD1$ == "GRAB" THEN
2390       KW = 1 : GET_OBJECTS_ROUTINE
2400     END IF
2410     :
2420     REMark ** NEXT LINE ACCEPTS 'DROP' 'PUT' OR 'LEAVE'
2430     IF WORD1$ == "DROP" OR WORD1$ == "PUT" OR WORD1$ == "LEAVE" THEN
2440       KW = 1 : DROP_OBJECTS_ROUTINE
2450     END IF
2460     :
2470     REMark ** NEXT LINE ACCEPTS 'UNLOCK' OR 'OPEN'
2480     REMark ** IF A DIRECTION GIVEN, UNLOCK THAT EXIT, BUT UNLOCK IN
2490     REMark ** BOTH DIRECTIONS
2500     IF WORD1$ == "UNLOCK" OR WORD1$ == "OPEN" THEN
2510       KW = 1 : UNLOCK_EXIT
2520     END IF
2530     :
2540     REMark *********************************************************
2550     REMark *   ADD ANY FURTHER TWO WORD COMMANDS HERE, USING THE   *
2560     REMark *   EXAMPLES ABOVE.                                     *
2570     REMark *********************************************************
2580     :
2590   END IF
2600   :
2610   REMark ***********************************************************
2620   REMark *  KW=1 MEANS KEYWORD UNDERSTOOD, 0 MEANS NOT UNDERSTOOD  *
2630   REMark ***********************************************************
2640   IF KW = 0 THEN
2650     REMark *****************************************
2660     REMark *  CHOOSE "I DON'T UNDERSTAND" MESSAGE  *
2670     REMark *****************************************
2680     RAN = RND(1 TO 3)
2690     SELect ON RAN
2700       =1 : PRINT #0,"It would not be wise to ";USER_INPUT$
2710       =2 : PRINT #0,"Only a fool would try to ";USER_INPUT$
2720       =3 : PRINT #0,"I don't understand ";USER_INPUT$
2730     END SELect
2740   END IF
2750   :
2760   PAUSE 50
2770   :
2780 END REPeat GAME
2790 :
2800 END_OF_GAME
2810 PRINT #0,"Program Finished."
2820 :
2830 REMark ********************************************
2840 REMark *  RESET BASIC WINDOWS AFTER RUNNING GAME  *
2850 REMark ********************************************
2860 REMark IF NOT COMPILED THEN WTV 4 : REMark OR WMON 4 IF YOU PREFER
2870 STOP
2880 :
2890 DEFine PROCedure MOVE_MONSTER (NUM)
2900   LOCal X,FLAG,OLD_ROOM,NEW_ROOM
2910   REMark ** WHERE IS MONSTER "NUM"?
2920   OLD_ROOM = 0 : NEW_ROOM = 0
2930   FOR X = 1 TO NO_OF_ROOMS-1
2940     IF MAP(X,8) = NUM THEN OLD_ROOM = X : EXIT X
2950   END FOR X
2960   IF OLD_ROOM = 0 THEN RETurn : REMark ** THIS MONSTER NOT PRESENT (PROBABLY SLAIN)
2970   REMark ** PICK AN EXIT AT RANDOM
2980   RAN = RND(1 TO 4)
2990   IF MAP(OLD_ROOM,RAN) > 0 THEN
3000     REMark ** THERE IS AN EXIT
3010     NEW_ROOM = MAP(OLD_ROOM,RAN)
3020     IF MAP(NEW_ROOM,8) = 0 THEN
3030       REMark ** NO MONSTER IN NEW ROOM, SO MOVE THERE
3040       MAP(NEW_ROOM,8) = NUM : REMark ** MOVE HERE
3050       MAP(OLD_ROOM,8) = 0   : REMark ** VACATE HERE
3060       INK #0,2
3070       IF RND > .5 THEN
3080         PRINT #0,"The ";MONSTER$(NUM);" moved room."
3090       ELSE
3100         PRINT #0,"The ";MONSTER$(NUM);" went walkies."
3110       END IF
3120       INK #0,7
3130     END IF
3140   END IF
3150 END DEFine MOVE_MONSTER
3160 :
3170 DEFine PROCedure VOCABULARY
3180   REMark ********************************************
3190   REMark *  SHOW LIST OF WORDS PROGRAM UNDERSTANDS  *
3200   REMark ********************************************
3210   PRINT #0,"List of commands:"
3220   PRINT #0,"HELP QUIT VOCABULARY KILL FIGHT ATTACK SLAY GO MOVE MAP"
3230   PRINT #0,"RUN WALK GET TAKE LIFT GRAB DROP PUT LEAVE UNLOCK OPEN."
3240 END DEFine VOCABULARY
3250 :
3260 DEFine PROCedure MOVEMENT_ROUTINE
3270   LOCal EXIT_NO
3280   REMark ********************************************
3290   REMark * MOVEMENT ROUTINE - CHECK THE ROOM EXITS. *
3300   REMark ********************************************
3310   WORD2$ = LEFT$(WORD2$,1) : EXIT_NO = WORD2$ INSTR "nsew"
3320   IF EXIT_NO = 0 THEN PRINT #0,"Go where?" : RETurn
3330   IF MAP(ROOM,EXIT_NO) <= 0 THEN
3340     IF MAP(ROOM,EXIT_NO) < 0 THEN
3350       PRINT #0,"That exit is locked."
3360     ELSE
3370       PRINT #0,"You can't go that way."
3380     END IF
3390     RETurn
3400   END IF
3410   :
3420   REMark ** EXIT IN SPECIFIED DIRECTION LEADS TO WHICH
3430   REMark ** ROOM NUMBER? SET 'ROOM' TO NEW ROOM NUMBER
3440   ROOM = MAP(ROOM,EXIT_NO)
3450 END DEFine MOVEMENT_ROUTINE
3460 :
3470 DEFine PROCedure UNLOCK_EXIT
3480   LOCal EXIT_NO, OBJ_NO, X, EXIT_TO
3490   REMark ********************************************
3500   REMark * IF CARRYING THE KEY (OBJECT 1),  AND THE *
3510   REMark * SPECIFIED EXIT IS A -VE NUMBER,UNLOCK IT *
3520   REMark * BY TURNING THE EXIT NUMBER +VE.          *
3530   REMark ********************************************
3540   WORD2$ = LEFT$(WORD2$,1) : EXIT_NO = WORD2$ INSTR 'nsew'
3550   IF EXIT_NO = 0 THEN PRINT #0,"Eh?" : RETurn
3560   REMark ** check if first object (key) being carried
3570   OBJ_NO = 0
3580   FOR X = 1 TO 5
3590     IF CARRIED(X) = 1 THEN OBJ_NO = 1 : EXIT X : REMark ** KEY
3600   END FOR X
3610   IF OBJ_NO <> 1 THEN PRINT #0,"No key!" : RETurn
3620   IF MAP(ROOM,EXIT_NO) = 0 THEN PRINT #0,"No exit that way." : RETurn
3630   IF MAP(ROOM,EXIT_NO) > 0 THEN PRINT #0,"Not locked."       : RETurn
3640   REMark ** EXIT IS LOCKED, SO UNLOCK FROM BOTH SIDES
3650   REMark ** FIRST, THIS SIDE
3660   MAP(ROOM,EXIT_NO) = ABS(MAP(ROOM,EXIT_NO))
3670   REMark ** NOW OTHER SIDE, UNLOCK EXIT IN OPPOSITE DIRECTION
3680   EXIT_TO = MAP(ROOM,EXIT_NO)
3690   IF EXIT_NO = 1 OR EXIT_NO = 3 THEN
3700     MAP(EXIT_TO,EXIT_NO+1) = ABS(MAP(EXIT_TO,EXIT_NO+1))
3710   ELSE
3720     MAP(EXIT_TO,EXIT_NO-1) = ABS(MAP(EXIT_TO,EXIT_NO-1))
3730   END IF
3740 END DEFine UNLOCK_EXIT
3750 :
3760 DEFine PROCedure SHOW_MAP
3770   REMark ********************************************
3780   REMark * PRINT A SIMPLE TEXT MAP-EDIT AS REQUIRED *
3790   REMark * FOR YOUR ROOM PLAN,INCLUDE AS MUCH OR AS *
3800   REMark * LITTLE DETAIL AS YOU WANT TO INCLUDE.    *
3810   REMark * CHANGE COLOURS, FOR EXAMPLE TO HIGHLIGHT *
3820   REMark * ENTRY/EXIT/LOCKED/OBJECTS/MONSTERS ETC.  *
3830   REMark ********************************************
3840   PRINT #0, : INK #0,4 : UNDER #0,1
3850   PRINT #0,"QL Forum Adventure Map" : UNDER #0,0
3860   INK #0,7 : PRINT #0,"ENTRY ->"; : INK #0,4
3870   PRINT #0," 01--02  03  04"
3880   PRINT #0,"         |       |   |"
3890   PRINT #0,"   N     05  06--07--08--"
3900   PRINT #0,"   |     |   |   |   |   |"
3910   PRINT #0," W-+-E   09--10  11  12  |"
3920   PRINT #0,"   |                     |"
3930   PRINT #0,"   S     13  14--15--16--"
3940   PRINT #0,"         |   |   | "
3950   PRINT #0,"         17--18  19--20"; : INK #0,7 : PRINT #0," <-EXIT"
3960   PRINT #0, : INK #0,7
3970   PRINT #0,"01-The Welcome Area                 11-The Feedback Section"
3980   PRINT #0,"02-New Users Lounge                 12-The Off-Topic Section"
3990   PRINT #0,"03-General QL Chat Area             13-The Site Announcements Room"
4000   PRINT #0,"04-Hardware Room                    14-The QL Services And Websites Section"
4010   PRINT #0,"05-Software And Programming Area    15-Rulebook Room"
4020   PRINT #0,"06-QL Emulation Cave                16-The Software Encyclopedia Section"
4030   PRINT #0,"07-Compatibles Corner               17-The For Sale Section"
4040   PRINT #0,"08-Quanta Prospective Members Area  18-The Wanted Cubicle"
4050   PRINT #0,"09-For Sale Room                    19-The Logout Passageway"
4060   PRINT #0,"10-The Wanted Corner                20-Exit"
4070   INK #0,2 : INPUT #0,\"Press ENTER to continue. ";Z$ : INK #0,7
4080 END DEFine SHOW_MAP
4090 :
4100 DEFine PROCedure INVENTORY
4110   LOCal COUNTER,DONE
4120   REMark ********************************************
4130   REMark * THE NEXT LINES CHECK TO SEE IF PLAYER IS *
4140   REMark * CARRYING ANYTHING AND THEN PRINT A LIST  *
4150   REMark ********************************************
4160   TOTAL = 0
4170   FOR COUNTER = 1 TO 5
4180     IF CARRIED(COUNTER) <> 0 THEN TOTAL = TOTAL + 1
4190   END FOR COUNTER
4200   :
4210   IF TOTAL > 0 THEN
4220     CASH = 0
4230     PRINT #0,\"You are carrying:";
4240     DONE = 0
4250     FOR COUNTER = 1 TO 5
4260       IF CARRIED(COUNTER) <> 0 THEN
4270         PRINT #0, OBJECT$(CARRIED(COUNTER));
4280         CASH = CASH + VALUE(CARRIED(COUNTER))
4290         DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
4300       END IF
4310     NEXT COUNTER
4320       PRINT #0,
4330     END FOR COUNTER
4340     IF CASH > 0 THEN
4350       PRINT #0,TO 8;"Total value - ";CURRENCY$;STR$(CASH)
4360     END IF
4370   END IF
4380 END DEFine INVENTORY
4390 :
4400 DEFine PROCedure GET_OBJECTS_ROUTINE
4410   LOCal FLAG, COUNTER, OBJ_NO
4420   REMark ******************************************************
4430   REMark * GET OBJECTS ROUTINE - PICK UP OBJECT IF PRESENT    *
4440   REMark * AND YOU ARE NOT ALREADY CARRYING MAXIMUM NUMBER    *
4450   REMark * OF OBJECTS                                         *
4460   REMark ******************************************************
4470   REMark ** CHECK IN CASE ALREADY CARRYING MAXIMUM NUMBER OF OBJECTS (5)
4480   FLAG = 0 : REMark COUNT OF NUMBER OF OBJECTS BEING CARRIED
4490   FOR COUNTER = 1 TO 5
4500     IF CARRIED(COUNTER) <> 0 THEN FLAG = FLAG + 1
4510   NEXT COUNTER
4520   IF FLAG = 5 THEN PRINT #0,"You are already carrying five objects." : RETurn
4530   :
4540   REMark ******************************************************
4550   REMark *  CHECK IF ANYTHING IN ROOM WHICH CAN BE PICKED UP  *
4560   REMark ******************************************************
4570   IF (MAP(ROOM,5)>0)+(MAP(ROOM,6)>0)+(MAP(ROOM,7)>0) = 0 THEN
4580     REMark ** NOTHING IN THIS ROOM TO BE PICKED UP
4590     PRINT #0,"I see nothing to pick up." : RETurn
4600   END IF
4610   :
4620   REMark ******************************************************
4630   REMark *  NOW PICK IT UP (C$ IS NAME OF OBJECT TO PICK UP)  *
4640   REMark *  ONLY ONE OBJECT CAN BE PICKED UP AT A TIME EVEN   *
4650   REMark *  IF THERE IS MORE THAN ONE WITH THE SAME NAME!     *
4660   REMark ******************************************************
4670   IF WORD2$ == "C5" THEN WORD2$ = "vanpeebles's C5"
4680   IF WORD2$ == OBJECT$(MAP(ROOM,5)) AND MAP(ROOM,5) > 0 THEN
4690     OBJ_NO = MAP(ROOM,5) : MAP(ROOM,5) = 0 : REMark FIRST OBJECT
4700   ELSE
4710     IF WORD2$ == OBJECT$(MAP(ROOM,6)) AND MAP(ROOM,6) > 0 THEN
4720       OBJ_NO = MAP(ROOM,6) : MAP(ROOM,6) = 0 : REMark SECOND OBJECT
4730     ELSE
4740       IF WORD2$ == OBJECT$(MAP(ROOM,7)) AND MAP(ROOM,7) > 0 THEN
4750         OBJ_NO = MAP(ROOM,7) : MAP(ROOM,7) = 0 : REMark THIRD OBJECT
4760       ELSE
4770         PRINT #0,WORD2$;" is not here." : RETurn
4780       END IF
4790     END IF
4800   END IF
4810   :
4820   REMark ** FIND AN EMPTY SPACE IN PICKED-UP OBJECTS LIST
4830   FOR COUNTER = 1 TO 5
4840     IF CARRIED(COUNTER) = 0 THEN
4850       CARRIED(COUNTER) = OBJ_NO : EXIT COUNTER : REMark INSERT IN FIRST FREE SLOT IN LIST
4860     END IF
4870   END FOR COUNTER
4880   PRINT #0,TO 3;">-> You now have the ";OBJECT$(OBJ_NO)
4890 END DEFine GET_OBJECTS_ROUTINE
4900 :
4910 DEFine PROCedure DROP_OBJECTS_ROUTINE
4920   LOCal FLAG, COUNTER, OBJ_NO
4930   REMark ******************************************************
4940   REMark * DROP OBJECT ROUTINE - FIRST COUNT HOW MANY BEING   *
4950   REMark * CARRIED AT THE MOMENT (0 = NONE, 1 = AT LEAST ONE  *
4960   REMark ******************************************************
4970   FLAG = 0
4980   FOR COUNTER = 1 TO 5
4990     IF CARRIED(COUNTER) <> 0 THEN
5000       FLAG = 1 : EXIT COUNTER : REMark SOMETHING BEING CARRIED
5010     END IF
5020   END FOR COUNTER
5030   IF FLAG = 0 THEN
5040     REMark ** NOTHING CURRENTLY BEING CARRIED
5050     PRINT #0,"You are not carrying anything."
5060     RETurn
5070   END IF
5080   :
5090   REMark ** IS THE ROOM ALREADY FULL OF OBJECTS?
5100   IF (MAP(ROOM,5)<>0) + (MAP(ROOM,6)<>0) + (MAP(ROOM,7)<>0) = 3 THEN
5110     REMark ** ROOM CAN ONLY HOLD 3 OBJECTS
5120     PRINT #0,"This room already holds its maximum number of objects."
5130     RETurn
5140   END IF
5150   :
5160   REMark ** TRY TO MATCH NAME OF OBJECT TO BE DROPPED WITH ITEM IN LIST OF OBJECTS
5170   OBJECT_NAME$  = "" : REMark OBJECT NAME
5180   OBJ_NO        = 0  : REMark OBJECT NUMBER
5190   FOR COUNTER = 1 TO NO_OF_OBJECTS
5200     IF OBJECT$(COUNTER) == WORD2$ THEN
5210       OBJECT_NAME$ = OBJECT$(COUNTER) : OBJ_NO = COUNTER : EXIT COUNTER : REMark NAME MATCHED
5220     END IF
5230   END FOR COUNTER
5240   IF OBJECT_NAME$ = "" THEN
5250     REMark ** THAT OBJECT NOT CURRENTLY BEING CARRIED
5260     PRINT #0,"How can you when you're not holding it."
5270     RETurn
5280   END IF
5290   :
5300   FOR COUNTER = 1 TO 5
5310     IF CARRIED(COUNTER) = OBJ_NO THEN CARRIED(COUNTER) = 0 : REMark RESET CARRIED ITEM NUMBER
5320   END FOR COUNTER
5330   :
5340   REMark ** ADD TO AN UNUSED ROOM OBJECT NUMBER
5350   IF MAP(ROOM,5) = 0 THEN
5360     MAP(ROOM,5) = OBJ_NO : REMark ROOM OBJECT 1
5370   ELSE
5380     IF MAP(ROOM,6) = 0 THEN
5390       MAP(ROOM,6) = OBJ_NO : REMark ROOM OBJECT 2
5400     ELSE
5410       IF MAP(ROOM,7) = 0 THEN MAP(ROOM,7) = OBJ_NO : REMark ROOM OBJECT 3
5420     END IF
5430   END IF
5440   PRINT #0,"You have dropped the ";OBJECT_NAME$;"."
5450 END DEFine DROP_OBJECTS_ROUTINE
5460 :
5470 DEFine PROCedure FIGHT_ROUTINE
5480   REMark *****************************************************
5490   REMark *  FIGHT ROUTINE - NEXT LINES CHECK IF A MONSTER    *
5500   REMark *  IS ACTUALLY PRESENT TO FIGHT OR NOT              *
5510   REMark *****************************************************
5520   IF MAP(ROOM,8) = 0 THEN
5530     REMark ** 0 MEANS NO MONSTER PRESENT, CHOOSE RANDOM MESSAGE
5540     RAN = RND(1 TO 3)
5550     SELect ON RAN
5560       =1 : PRINT #0,"There is nothing to fight here."
5570       =2 : PRINT #0,"You can't fight empty air."
5580       =3 : PRINT #0,"No monster here to fight!"
5590     END SELect
5600     RETurn
5610   END IF
5620   :
5630   REMark ** SET G$ TO NAME OF MONSTER AND CREATE ITS ATTRIBUTES
5640   MONSTER_NAME$ = MONSTER$(MAP(ROOM,8))
5650   M_STRE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5660   M_CHAR = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5670   M_DEXT = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5680   M_INTE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5690   M_WISD = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5700   M_CONS = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3
5710   REMark ** USE 'AN' BEFORE A VOWEL, 'A' BEFORE A CONSONANT
5720   PRINT #0,"Your opponent is a";
5730   IF MONSTER_NAME$(1) INSTR "AEIOU" THEN PRINT #0,"n";
5740   PRINT #0," ";MONSTER_NAME$;", ";
5750   MONSTER_TALLY = 0 : REMark ** MONSTER'S TALLY
5760   HUMAN_TALLY   = 0 : REMark ** HUMAN'S TALLY
5770   FIGHT_FLAG = M_STRE * RND(1 TO 6) : REMark DANGER LEVEL
5780   PRINT #0,"the ";MONSTER_NAME$;"'s danger level is ";FIGHT_FLAG;"."
5790   PAUSE 25
5800   :
5810   REMark ** CHECK IF CARRYING WEAPONS
5820   REMark ** RUN THROUGH CARRIED ITEMS LIST TO CHECK FOR WEAPONS
5830   FLAG = 0
5840   FOR COUNTER = 1 TO 5
5850     IF CARRIED(COUNTER) <> 0 THEN
5860       IF WEAPON(CARRIED(COUNTER)) <> 0 THEN
5870         FLAG = FLAG + 1
5880         WEAPONS(FLAG) = CARRIED(COUNTER)
5890       END IF
5900     END IF
5910   END FOR COUNTER
5920   REMark ** WEAPONS() HOLDS A LIST OF WEAPONS BEING CARRIED
5930   REMark ** FLAG IS NUMBER OF WEAPONS
5940   SELect ON FLAG
5950     =0 : REMark ** NO WEAPONS CARRIED
5960          PRINT #0,"You must fight the ";MONSTER_NAME$;" with your bare hands."
5970     =1 : REMark ** A SINGLE WEAPON TO FIGHT WITH
5980          PRINT #0,"You must fight with your ";OBJECT$(WEAPONS(1));"."
5990          CHOICE = WEAPONS(1)
6000          FIGHT_FLAG = INT(FIGHT_FLAG*2/(CHOICE+3))
6010     =REMAINDER : REMark ** MORE THAN ONE WEAPON
6020          PRINT #0,"Choose your weapon:"
6030          FOR COUNTER = 1 TO FLAG
6040            PRINT #0,COUNTER;" - ";OBJECT$(WEAPONS(COUNTER))
6050          END FOR COUNTER
6060          REPeat ENTER
6070            INPUT #0,"Enter the number you choose ";CHOICE
6080            IF CHOICE > 0 AND CHOICE <= FLAG AND CHOICE = INT(CHOICE) THEN EXIT ENTER
6090            PRINT #0,"Please enter 1 to ";FLAG;"." : REMark ** OOPS
6100          END REPeat ENTER
6110          PRINT #0,"Right, so you choose to fight with the ";OBJECT$(WEAPONS(CHOICE));"."
6120          CHOICE = WEAPONS(CHOICE)
6130          FIGHT_FLAG = INT(FIGHT_FLAG*2/(CHOICE+3))
6140   END SELect
6150   :
6160   PAUSE 25
6170   :
6180   INK #0,4
6190   PRINT #0,"The ";MONSTER_NAME$;" has the following attributes:"
6200   PRINT #0,"   Strength     ";M_STRE TO 20;"  Charisma ";M_CHAR TO 36;"  Dexterity    ";M_DEXT
6210   PRINT #0,"   Intelligence ";M_INTE TO 20;"  Wisdom   ";M_WISD TO 36;"  Constitution ";M_CONS
6220   INK #0,7
6230   PRINT #0,"Your attributes are:"
6240   PRINT #0," 1-Strength     ";H_STRE TO 20;"2-Charisma ";H_CHAR TO 36;"3-Dexterity    ";H_DEXT
6250   PRINT #0," 4-Intelligence ";H_INTE TO 20;"5-Wisdom   ";H_WISD TO 36;"6-Constitution ";H_CONS
6260   PRINT #0,"Which attributes will you fight with (2 attributes) ?"
6270   REPeat ENTER
6280     INPUT #0,"Attribute 1:";ATTR1 TO 20;"Attribute 2:";ATTR2
6290     IF ATTR1 > 0 AND ATTR1 < 7 AND ATTR2 > 0 AND ATTR2 < 7 AND ATTR1 <> ATTR2 AND ATTR1 = INT(ATTR1) AND ATTR2 = INT(ATTR2) THEN
6300       EXIT ENTER : REMark ** VALID ENTRY
6310     END IF
6320     REMark ** TRY AGAIN...
6330     PRINT #0,"** Don't fool around with a ";MONSTER_NAME$;" in the room with you!! **"
6340   END REPeat ENTER
6350   IF (ATTR1=1) OR (ATTR2=1) THEN MONSTER_TALLY = MONSTER_TALLY + M_STRE : HUMAN_TALLY = HUMAN_TALLY + H_STRE
6360   IF (ATTR1=2) OR (ATTR2=2) THEN MONSTER_TALLY = MONSTER_TALLY + M_CHAR : HUMAN_TALLY = HUMAN_TALLY + H_CHAR
6370   IF (ATTR1=3) OR (ATTR2=3) THEN MONSTER_TALLY = MONSTER_TALLY + M_DEXT : HUMAN_TALLY = HUMAN_TALLY + H_DEXT
6380   IF (ATTR1=4) OR (ATTR2=4) THEN MONSTER_TALLY = MONSTER_TALLY + M_INTE : HUMAN_TALLY = HUMAN_TALLY + H_INTE
6390   IF (ATTR1=5) OR (ATTR2=5) THEN MONSTER_TALLY = MONSTER_TALLY + M_WISD : HUMAN_TALLY = HUMAN_TALLY + H_WISD
6400   IF (ATTR1=6) OR (ATTR2=6) THEN MONSTER_TALLY = MONSTER_TALLY + M_CONS : HUMAN_TALLY = HUMAN_TALLY + H_CONS
6410   IF HUMAN_TALLY = MONSTER_TALLY THEN
6420     PRINT #0,TO 10;"You are evenly matched."
6430   ELSE
6440     PRINT #0,"It looks like the odds are in favour of ";
6450     IF HUMAN_TALLY > MONSTER_TALLY THEN PRINT #0,"you." : ELSE PRINT #0,"the ";MONSTER_NAME$;"." : END IF
6460   END IF
6470   PAUSE RND(50 TO 100)
6480   :
6490   REMark *****************************************
6500   REMark *  NEXT LINES CONTROL THE FIGHT ITSELF  *
6510   REMark *****************************************
6520   PREV_ACTION = 0
6530   REPeat FIGHT
6540     ACTION = RND(1 TO 10)
6550     IF ACTION = PREV_ACTION THEN NEXT FIGHT : REMark ** MUST NOT BE EQUAL TO PREVIOUS
6560     PREV_ACTION = ACTION
6570     PRINT #0,"The ";MONSTER_NAME$;": ";MONSTER_TALLY;", You: ";HUMAN_TALLY
6580     PAUSE RND(25 TO 100)
6590     SELect ON ACTION
6600       =1 : PRINT #0,"You struck a splendid blow!"                   : MONSTER_TALLY = MONSTER_TALLY - 1
6610       =2 : PRINT #0,"The ";MONSTER_NAME$;" strikes out."            : HUMAN_TALLY = HUMAN_TALLY - 1 : H_CHAR = H_CHAR - 1
6620       =3 : PRINT #0,"You draw the ";MONSTER_NAME$;"'s blood."       : M_STRE = M_STRE - 1
6630       =4 : PRINT #0,"You are wounded!!"                             : H_INTE = H_INTE - 1
6640       =5 : PRINT #0,"The ";MONSTER_NAME$;" is tiring."              : M_DEXT = M_DEXT - 1
6650       =6 : PRINT #0,"You are bleeding..."                           : H_WISD = H_WISD - 1
6660       =7 : PRINT #0,"You wound the ";MONSTER_NAME$;"."              : MONSTER_TALLY = MONSTER_TALLY - 1
6670       =8 : PRINT #0,"Heavy blow by the ";MONSTER_NAME$;"."          : HUMAN_TALLY = HUMAN_TALLY - 1 : H_INTE = H_INTE - 1
6680       =9 : PRINT #0,"You knocked the ";MONSTER_NAME$;" over."       : MONSTER_TALLY = MONSTER_TALLY - 1
6690       =10: PRINT #0,"The ";MONSTER_NAME$;" sees stars momentarily." : MONSTER_TALLY = MONSTER_TALLY - 1
6700     END SELect
6710     :
6720     REMark ** EITHER 1 IN 4 CHANCE OF ENDING THE FIGHT, OR ATTRIBUTES=0
6730     REMark ** MONSTER_TALLY DECREMENTED TWICE AS MUCH AS HUMAN_TALLY DURING FIGHT
6740     REMark ** ALLOWING HUMAN TO WIN SLIGHTLY MORE FIGHTS THAN THE MONSTERS
6750     IF RND <= .25 OR HUMAN_TALLY = 0 OR MONSTER_TALLY = 0 THEN EXIT FIGHT
6760     :
6770     PAUSE RND(50 TO 100) : REMark ** RANDOM SHORT PAUSE BETWEEN BLOWS
6780   END REPeat FIGHT
6790   :
6800   PAUSE RND(50 TO 100)
6810   IF HUMAN_TALLY >= MONSTER_TALLY THEN
6820     REMark ** PLAYER WINS
6830     PRINT #0,"You have slain the ";MONSTER_NAME$
6840     IF MONSTER_NAME$ == "Red Dragon" THEN INK #0,2 : PRINT #0,"The Dilwyn will not be amused." : INK #0,7
6850     IF MONSTER_NAME$ == "Dilwyn" AND RND > .5 THEN INK #0,2 : PRINT #0,"The Red Dragon is heartbroken." : INK #0,7
6860     IF MONSTER_NAME$ == 'XorA' THEN
6870       IF RND > .5 THEN
6880         PRINT #0,"With his dying breath, the XorA monster reluctantly reveals to you that the"\"password book is in"
6890       ELSE
6900         PRINT #0,"As the XorA monster lay dying, you tortured out of him the location of the Password"\"Book, which is"
6910       END IF
6920       FOR X = 1 TO NO_OF_ROOMS
6930         FOR Y = 5 TO 7
6940           IF MAP(X,Y) = -1 THEN
6950             REMark ** PASSWORD BOOK HERE
6960             MAP(X,Y) = ABS(MAP(X,Y))
6970             DISPLAY_ROOM_DESCRIPTION X,1 : REMark ** ROOM DESCRIPTION ONLY
6980             EXIT X
6990           END IF
7000         END FOR Y
7010       END FOR X
7020     END IF
7030     H_STRE = H_STRE + 2 : H_DEXT = H_DEXT + 2 : H_WISD = H_WISD + 2
7040     H_CHAR = H_CHAR + 2 : H_INTE = H_INTE + 2 : H_CONS = H_CONS + 2
7050     MONSTERS_KILLED = MONSTERS_KILLED + 1
7060     MAP(ROOM,8) = 0 : REMark ** RESET MONSTER IN THIS ROOM
7070   ELSE
7080     REMark ** MONSTER WINS
7090     PRINT #0,"The ";MONSTER_NAME$;" got the better of you that time..."
7100     IF (ATTR1=1) OR (ATTR2=1) THEN H_STRE = 4 * INT(H_STRE/5)
7110     IF (ATTR1=2) OR (ATTR2=2) THEN H_CHAR = 3 * INT(H_CHAR/4)
7120     IF (ATTR1=3) OR (ATTR2=3) THEN H_DEXT = 6 * INT(H_DEXT/7)
7130     IF (ATTR1=4) OR (ATTR2=4) THEN H_INTE = 2 * INT(H_INTE/3)
7140     IF (ATTR1=5) OR (ATTR2=5) THEN H_WISD = 5 * INT(H_WISD/6)
7150     IF (ATTR1=6) OR (ATTR2=6) THEN H_CONS = INT(H_CONS/2)
7160     REMark ** MONSTER IS EXHAUSTED AFTER FIGHT, SO HIDES BRIEFLY
7170     REMark ** SO THAT THE FIGHT DOES NOT RESUME IMMEDIATELY
7180     MAP(ROOM,8) = -MAP(ROOM,8) : REMark ** -VE = HIDDEN
7190   END IF
7200   :
7210   MAP(ROOM,8) = 0 : REMark ** RESET MONSTER IN THIS ROOM
7220   :
7230   PAUSE RND(50 TO 100)
7240 END DEFine FIGHT_ROUTINE
7250 :
7260 DEFine PROCedure END_OF_GAME
7270   REMark *************************
7280   REMark *   END OF GAME REPORT  *
7290   REMark *************************
7300   LOCal Z$
7310   PRINT
7320   SCORE = 0 : REMark ** SCORE
7330   SELect ON QUIT_FLAG
7340     =1 : REMark ** SUCCESSFUL COMPLETION
7350          PRINT #0,\"CONGRATULATIONS... You have completed the ADVENTURE!!!!"
7360          SCORE = 100
7370          PRINT
7380     =2 : REMark ** EXHAUSTION
7390          PRINT #0,\"Unfortunately, you are exhausted... So this adventure must end."
7400     =4 : REMark ** "QUIT" COMMAND
7410          PRINT #0,"I did not imagine you would turn out to be a quitter!"
7420   END SELect
7430   :
7440   REMark ** PRINT CLOSING SUMMARY FOR THIS GAME
7450   SCORE = 99 * (SCORE + 20*CASH + 4*MONSTERS_KILLED + H_STRE + 2*H_CHAR + 3*H_DEXT + 4 + H_INTE + 5*H_WISD + 6*H_CONS)/QUIT_FLAG
7460   :
7470   REMark ** SHOW HOW MANY MONSTERS KILLED
7480   IF MONSTERS_KILLED > 0 THEN
7490     PRINT #0,"You killed ";MONSTERS_KILLED;" monster";
7500     IF MONSTERS_KILLED = 1 THEN PRINT #0,"." : ELSE PRINT #0,"s." : END IF
7510   END IF
7520   :
7530   REMark ** VALUE OF TREASURE FOUND
7540   PRINT #0,"You found ";CURRENCY$;STR$(CASH);" worth of treasure."
7550   :
7560   REMark ** ROUND OFF FINAL SCORE TO WHOLE NUMBER
7570   PRINT #0,"Your score for this adventure is ";INT(SCORE+.5);"."
7580   PRINT #0,\"Thank you for playing ";(TITLE$)
7590   INPUT #0,"Save game status Y/N ? ";Z$
7600   IF CODE(Z$) = CODE("y") OR CODE(Z$) = CODE("Y") THEN SAVE_GAME_STATUS
7610 END DEFine END_OF_GAME
7620 :
7630 DEFine PROCedure SAVE_GAME_STATUS
7640   INPUT #0,"Enter filename to save game status > ";FILENAME$
7650   IF FILENAME$ = "" THEN RETurn
7660   PRINT #0,"Saving ";FILENAME$;"..."
7670   DELETE FILENAME$ : OPEN_NEW #3,FILENAME$
7680   PRINT #3,ROOM : REMark CURRENT ROOM
7690   PRINT #3,NO_OF_ROOMS : REMark NUMBER OF ROOMS
7700   FOR X = 1 TO NO_OF_ROOMS
7710     FOR Y = 1 TO 8
7720       PRINT #3,MAP(X,Y) : REMark CURRENT MAP STATUS
7730     END FOR Y
7740   END FOR X
7750   FOR X = 1 TO 5
7760     PRINT #3,CARRIED(X) : REMark OBJECTS BEING CARRIED
7770   END FOR X
7780   PRINT #3,MONSTERS_KILLED : REMark NUMBER OF MONSTERS SLAIN
7790   PRINT #3,H_STRE\H_CHAR\H_DEXT\H_INTE\H_WISD\H_CONS : REMark CURRENT ATTRIBUTES
7800   PRINT #3,CASH : REMark TOTAL VALUE OF OBJECTS CARRIED, NORMALLY CALCULATED IN "INVENTORY" PROCEDURE
7810   CLOSE #3
7820 END DEFine SAVE_GAME_STATUS
7830 :
7840 DEFine PROCedure LOAD_GAME_STATUS
7850   OPEN_IN #3,FILENAME$
7860   INPUT #3,ROOM : REMark CURRENT ROOM
7870   INPUT #3,NO_OF_ROOMS : REMark NUMBER OF ROOMS
7880   FOR X = 1 TO NO_OF_ROOMS
7890     FOR Y = 1 TO 8
7900       INPUT #3,MAP(X,Y) : REMark CURRENT MAP STATUS
7910     END FOR Y
7920   END FOR X
7930   FOR X = 1 TO 5
7940     INPUT #3,CARRIED(X) : REMark OBJECTS BEING CARRIED
7950   END FOR X
7960   INPUT #3,MONSTERS_KILLED : REMark NUMBER OF MONSTERS SLAIN
7970   INPUT #3,H_STRE : INPUT #3,H_CHAR : INPUT #3,H_DEXT : REMark CURRENT
7980   INPUT #3,H_INTE : INPUT #3,H_WISD : INPUT #3,H_CONS : REMark ATTRIBUTES
7990   INPUT #3,CASH
8000   CLOSE #3
8010 END DEFine LOAD_GAME_STATUS
8020 :
8030 DEFine PROCedure DISPLAY_ROOM_DESCRIPTION (ROOM_NO, ROOM_ONLY)
8040   LOCal ROOM
8050   REMark *****************************************
8060   REMark *  ADD ROOM DESCRIPTIONS AS REQUIRED    *
8070   REMark *  NO DESCRIPTION REQUIRED FOR THE      *
8080   REMark *  HIGHEST ROOM NUMBER (THE EXIT ROOM)  *
8090   REMark *****************************************
8100   :
8110   ROOM = ROOM_NO
8120   IF ROOM_ONLY = 0 THEN
8130     INK #0,4
8140     IF ROOM_NO = 1 THEN PRINT #0,\"Welcome to "; : ELSE PRINT #0,\"You are in ";
8150   END IF
8160   :
8170   SELect ON ROOM
8180     =1 : REMark ** ROOM 1
8190          PRINT #0,"The Welcome Area";
8200          :
8210     =2 : REMark ** ROOM 2
8220          PRINT #0,"New Users Lounge";
8230          :
8240     =3 : REMark ** ROOM 3
8250          PRINT #0,"General QL Chat Area";
8260          :
8270     =4 : REMark ** ROOM 4
8280          PRINT #0,"Hardware Room";
8290          :
8300     =5 : REMark ** ROOM 5
8310          PRINT #0,"Software And Programming Area";
8320          :
8330     =6 : REMark ** ROOM 6
8340          PRINT #0,"QL Emulation cave";
8350          :
8360     =7 : REMark ** ROOM 7
8370          PRINT #0,"Compatibles Corner";
8380          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0," (who knows what goes on here)";
8390          :
8400     =8 : REMark ** ROOM 8
8410          PRINT #0,"Quanta Prospective Members area";
8420          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0," (area of lost souls)"
8430          :
8440     =9 : REMark ** ROOM 9
8450          PRINT #0,"The For Sale room";
8460          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0," (your soul may be sold to QL Forum here)";
8470          :
8480     =10: REMark ** ROOM 10
8490          PRINT #0,"The 'Wanted' corner";
8500          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0," ('Wanted' to feed the monsters)";
8510          :
8520     =11: REMark ** ROOM 11
8530          PRINT #0,"The Feedback section";
8540          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0," (feedback: monsters describe you as very tasty)";
8550          :
8560     =12: REMark ** ROOM 12
8570          PRINT #0,"The Off-Topic Section";
8580          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0," (anything could happen to you in here)";
8590          :
8600     =13: REMark ** ROOM 13
8610          PRINT #0,"The Site Announcements room";
8620          :
8630     =14: REMark ** ROOM 14
8640          PRINT #0,"The QL Services And Websites section";
8650          :
8660     =15: REMark ** ROOM 15
8670          PRINT #0,"The dreaded Rulebook Room.";
8680          :
8690     =16: REMark ** ROOM 16
8700          PRINT #0,"The Software Encyclopedia section";
8710          :
8720     =17: REMark ** Room 17
8730          PRINT #0,"The For Sale area";
8740          IF RND > .5 AND ROOM_ONLY = 0 THEN PRINT #0,". Many a poor soul has been lost or sold in this room";
8750          :
8760     =18: REMark ** Room 18
8770          PRINT #0,"The Wanted cubicle";
8780          PRINT #0," (the monsters want your soul!)";
8790          :
8800     =19: REMark ** Room 19
8810          PRINT #0,"The Logout Passageway";
8820          IF MAP(ROOM,3) < 0 AND ROOM_ONLY = 0 THEN PRINT #0,\"(remember, you need the password from the XorA's secret password book to get out of the maze)";
8830   END SELect
8840   REMark ** ADDED FOR WHEN REVEALING PASSWORD BOOK
8850   PRINT #0, : INK #0,7
8860   IF ROOM_ONLY = 1 THEN RETurn
8870   :
8880   REMark *****************************************
8890   REMark *  WHERE ARE THE EXITS FROM THIS ROOM?  *
8900   REMark *    FIRST COUNT THE NUMBER OF EXITS    *
8910   REMark *****************************************
8920   EXITS = (MAP(ROOM,1)<>0) + (MAP(ROOM,2)<>0) + (MAP(ROOM,3)<>0) + (MAP(ROOM,4)<>0)
8930   SELect ON EXITS
8940     =0 : REMark ** NO EXITS, SAY NOTHING! (SHOULDN'T HAPPEN)
8950     =1 : REMark ** ONE EXIT ONLY
8960          PRINT #0,"There is an exit ";
8970          FOR X = 1 TO 4
8980            IF MAP(ROOM,X) <> 0 THEN
8990              PRINT #0,DIRECTION$(X);
9000              LOCKED_OR_NOT ROOM,X : REMark PRINT" (locked)" if required
9010              PRINT #0,"."
9020            END IF
9030          END FOR X
9040     =REMAINDER : REMark ** MORE THAN ONE EXIT
9050          PRINT #0,"There are exits ";
9060          DONE = 0 : REMark how many printed so far
9070          IF MAP(ROOM,1) <> 0 THEN
9080            PRINT #0,"North"; : LOCKED_OR_NOT ROOM,1 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
9090          END IF
9100          IF MAP(ROOM,2) <> 0 THEN
9110            PRINT #0,"South"; : LOCKED_OR_NOT ROOM,2 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
9120          END IF
9130          IF MAP(ROOM,3) <> 0 THEN
9140            PRINT #0,"East";  : LOCKED_OR_NOT ROOM,3 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
9150          END IF
9160          IF MAP(ROOM,4) <> 0 THEN
9170            PRINT #0,"West";  : LOCKED_OR_NOT ROOM,4 : DONE = DONE + 1
9180          END IF
9190          PRINT #0,"."
9200   END SELect
9210   :
9220 END DEFine DISPLAY_ROOM_DESCRIPTION
9230 :
9240 DEFine PROCedure LIST_SEPARATOR (ENTRY_NO,LIST_SIZE)
9250   REMark *****************************************
9260   REMark * INSERT "," / "AND" BETWEEN LIST ITEMS *
9270   REMark *****************************************
9280   IF ENTRY_NO < (LIST_SIZE-1) THEN
9290     PRINT #0,", ";
9300   ELSE
9310     IF ENTRY_NO = (LIST_SIZE-1) THEN PRINT #0," and ";
9320   END IF
9330 END DEFine LIST_SEPARATOR
9340 :
9350 DEFine PROCedure LOCKED_OR_NOT(ROOM_NUMBER,EXIT_NUMBER)
9360   REMark ****************************************
9370   REMark * INDICATE IF THIS EXIT LOCKED OR NOT  *
9380   REMark ****************************************
9390   IF MAP(ROOM_NUMBER,EXIT_NUMBER) < 0 THEN PRINT #0," (locked)";
9400 END DEFine LOCKED_OR_NOT
9410 :
9420 DEFine PROCedure SHOW_INTRODUCTORY_TEXT
9430   REMark ****************************************
9440   REMark * PRINT A GENERAL INTRODUCTION FOR THE *
9450   REMark * GAME HERE (OR MAY BE LEFT BLANK)     *
9460   REMark ****************************************
9470   PRINT #0,
9480   PRINT #0,"Venture into the QL Forum dungeons to steal their Gold Cards and other treasures."
9490   PRINT #0,
9500   PRINT #0,"Unfortunately for you, custodian monsters of the Forum (vanpeebles and RobHeaton)"
9510   PRINT #0,"will do anything in their power to protect their precious QL interfaces. As you"
9520   PRINT #0,"don't have a password to unlock the door to get back out of the maze, you must track"
9530   PRINT #0,"down their evil moderator henchman XorA, who is custodian of the Password Book you"
9540   PRINT #0,"need, and who will only reveal the secret location of the Password Book with his"
9550   PRINT #0,"dying breath."
9560   PRINT #0,
9570   PRINT #0,"An unusual small assortment of weapons is available to you to fight the monsters in"
9580   PRINT #0,"the maze, including a patio chair and some 1% strength beer."
9590   PRINT #0,
9600   PRINT #0,"Oh, and I almost hate to mention this, beware of the dreaded Welshman (whose name"
9610   PRINT #0,"we don't try to pronounce), who wanders around the maze with his pet fire-breathing"
9620   PRINT #0,"Red Dragon, causing havoc and picking fights wherever they go. And just to make"
9630   PRINT #0,"matters that little bit more interesting, beware of the RWAP and Swenson monsters"
9640   PRINT #0,"who lurk in the Forum dungeons waiting to pick on you."
9650   PRINT #0,
9660   PRINT #0,"We've logged you in. Feel free to explore the maze. Good luck - you'll need it."
9670   PRINT #0,
9680   INK #0,2 : INPUT #0,"Press ENTER to get started, or enter filename of saved game status file"\FILENAME$ : INK #0,7 : CLS #0
9690   IF FILENAME$ <> "" THEN LOAD_GAME_STATUS
9700 END DEFine SHOW_INTRODUCTORY_TEXT
9710 :
9720 DEFine PROCedure DESCRIBE_OBJECTS_IN_ROOM
9730   LOCal TOTAL,DONE
9740   REMark ****************************************
9750   REMark *  DESCRIBE OBJECTS SEEN IN THIS ROOM  *
9760   REMark *  FIRST,COUNT NUMBER OF OBJECTS HERE  *
9770   REMark ****************************************
9780   TOTAL = (MAP(ROOM,5) > 0) + (MAP(ROOM,6) > 0) + (MAP(ROOM,7) > 0)
9790   DONE = 0
9800   PRINT #0,"You can see :";
9810   IF MAP(ROOM,5) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,5)); : DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
9820   IF MAP(ROOM,6) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,6)); : DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
9830   IF MAP(ROOM,7) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,7));
9840   PRINT #0,
9850   PAUSE RND(25 TO 50)
9860 END DEFine DESCRIBE_OBJECTS_IN_ROOM
9870 :
9880 DEFine PROCedure INITIALISE
9890   REMark **************************************************************
9900   REMark * INITIALISE THE ADVENTURE MAP - ROOMS, OBJECTS AND MONSTERS *
9910   REMark * HEAVILY COMMENTED AS THIS IS CENTRAL TO THE PROGRAM.       *
9920   REMark **************************************************************
9930   LOCal X,Y,RAN,CHOOSE_EMPTY,OB_NO,TOTAL,INSERT_AT
9940   :
9950   RESTORE
9960   :
9970   REMark ** TITLE$ is the name of the adventure, as printed to screen
9980   READ TITLE$
9990   :
10000   REMark ** CURRENCY$ is whether values are reported in Pounds, Dollars, Euros...
10010   READ CURRENCY$
10020   :
10030   REMark MAIN GAME ARRAYS:
10040   REMark   MAP() : ROOM PROPERTIES
10050   REMark   MAP(ROOM,1) - EXIT NORTH TO ROOM NUMBER (0=NO EXIT)
10060   REMark   MAP(ROOM,2) - EXIT SOUTH TO ROOM NUMBER (0=NO EXIT)
10070   REMark   MAP(ROOM,3) - EXIT EAST  TO ROOM NUMBER (0=NO EXIT)
10080   REMark   MAP(ROOM,4) - EXIT WEST  TO ROOM NUMBER (0=NO EXIT)
10090   REMark   MAP(ROOM,5) - OBJECT 1 IN THIS ROOM (0=NONE)
10100   REMark   MAP(ROOM,6) - OBJECT 2 IN THIS ROOM (0=NONE)
10110   REMark   MAP(ROOM,7) - OBJECT 3 IN THIS ROOM (0=NONE)
10120   REMark   MAP(ROOM,8) - MONSTER TYPE IN THIS ROOM (0=NONE)
10130   REMark
10140   REMark   CARRIED()   - ITEMS PICKED UP IF NON-ZERO
10150   REMark
10160   REMark   OBJECT$()   - OBJECT/TREASURE NAME
10170   REMark   VALUE()     - OBJECT/TREASURE VALUE
10180   REMark   WEAPON()    - 1=THIS IS A WEAPON, 0=NOT A WEAPON
10190   REMark
10200   REMark   MONSTER$()  - NAMES OF MONSTERS
10210   REMark
10220   REMark   WEAPONS()   - WEAPONS CARRIED
10230   REMark
10240   READ NO_OF_ROOMS    : REMark ** 1-n  (n=EXIT ROOM)
10250   READ ROOM           : REMark ** START IN THIS ROOM NUMBER
10260   READ NO_OF_OBJECTS  : REMark ** HOW MANY OBJECTS IN TOTAL
10270   READ NO_OF_MONSTERS : REMark ** TOTAL NUMBER OF MONSTERS
10280   :
10290   REMark ** ARRAYS USED TO HOLD DETAILS OF MAP, MONSTERS, OBJECTS ETC
10300   DIM MAP(NO_OF_ROOMS,8)          : REMark MAP OF ROOM EXITS
10310   DIM CARRIED(5)                  : REMark OBJECTS PICKED UP BY PLAYER
10320   DIM OBJECT$(NO_OF_OBJECTS,20)   : REMark OBJECT/TREASURE NAME
10330   DIM VALUE(NO_OF_OBJECTS)        : REMark OBJECT/TREASURE VALUE
10340   DIM WEAPON(NO_OF_OBJECTS)       : REMark 1=A WEAPON, 0=NOT A WEAPON
10350   DIM MONSTER$(NO_OF_MONSTERS,20) : REMark MONSTER NAME
10360   DIM WEAPONS(5)                  : REMark WEAPONS CARRIED
10370   DIM DIRECTION$(4,10)            : REMark DIRECTION NAMES
10380   DIRECTION$(1) = 'Northward' : DIRECTION$(2) = 'Southward'
10390   DIRECTION$(3) = 'Eastward'  : DIRECTION$(4) = 'Westward'
10400   :
10410   REMark ** NEXT LINES DECIDE HUMAN ATTRIBUTES
10420   H_STRE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark STRENGTH
10430   H_CHAR = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark CHARISMA
10440   H_DEXT = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark DEXTERITY
10450   H_INTE = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark INTELLIGENCE
10460   H_WISD = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark WISDOM
10470   H_CONS = INT(RND(0 TO 5) + RND(0 TO 5) + RND(0 TO 5)) + 3 : REMark CONSTITUTION
10480   :
10490   CASH            = 0  : REMark ** TREASURE
10500   QUIT_FLAG       = 1  : REMark ** END OF GAME FLAG (1=SUCCESS, 2=EXHAUSTION, 4=QUIT COMMAND)
10510   MONSTERS_KILLED = 0  : REMark ** MONSTERS KILLED
10520   WORD1$          = "" : REMark ** FIRST WORD OF 2-WORD USER ENTRIES
10530   WORD2$          = "" : REMark ** SECOND WORD OF 2-WORD USER ENTRIES
10540   :
10550   REMark ** SET UP ROOMS
10560   FOR X = 1 TO NO_OF_ROOMS
10570     FOR Y = 1 TO 4 : READ MAP(X,Y)
10580   END FOR X
10590   :
10600   REMark ** DISTRIBUTE TREASURE, BUT IF A KEY IS REQUIRED
10610   REMark ** PLACE IT FIRST, BEFORE ANY LOCKED DOOR IN THE
10620   REMark ** OBJECTS HELD IN ROOMS  MAP(N,5) TO MAP(N,7)
10630   REMark ** NEGATIVE OBJECT NUMBERS MAKE OBJECT INVISIBLE
10640   REMark ** (SO THAT ANOTHER ACTION NEEDED TO MAKE VISIBLE)
10650   REMark ** GET LIST OF OBJECT NAMES AND OBJECT VALUES
10660   FOR X = 1 TO NO_OF_OBJECTS : READ OBJECT$(X),VALUE(X),WEAPON(X)
10670   :
10680   REMark ** PLACE KEY (OBJECT #1) IN SPECIFIED LOCATION
10690   REMark ** IF NOT USING LOCKED DOORS, OR NO KEY AT ALL
10700   REMark ** CHANGE LOOP TO for ob_no=1 to 8
10710   REMark ** REMEMBER KEY MUST BE *BEFORE* ANY LOCKED EXITS
10720   MAP(RND(1 TO 19),5) = -1 : REMark ** PASSWORD BOOK LOCATION,HIDDEN UNTIL XorA MONSTER KILLED
10730   TOTAL = 1 : REMark ** HOW MANY OBJECTS PLACED SO FAR
10740   INSERT_AT = 5 : REMark ** TRY TO USE LOWER LOCATIONS IN ROOM
10750   FOR OB_NO = 2 TO NO_OF_OBJECTS
10760     REPeat CHOOSE_EMPTY
10770       RAN = RND(1 TO NO_OF_ROOMS-1) : REMark ** RANDOM ROOM NUMBER
10780       IF MAP(RAN,INSERT_AT) = 0 : EXIT CHOOSE_EMPTY : REMark ** FIRST OBJECT LOCATION (ONLY) IN ROOM
10790     END REPeat CHOOSE_EMPTY
10800     MAP(RAN,INSERT_AT) = OB_NO : REMark ** PLACE OBJECT NO. IN ROOM
10810     TOTAL = TOTAL + 1
10820     INSERT_AT = 5+(TOTAL DIV (NO_OF_ROOMS-1))
10830     IF INSERT_AT > 7 THEN EXIT OB_NO : REMark all locations full
10840   END FOR OB_NO
10850   PRINT
10860   :
10870   REMark ** DISTRIBUTE MONSTERS AMONG ROOMS AT RANDOM
10880   REMark ** MONSTERS HELD IN ROOMS  MAP(N,8)
10890   FOR COUNTER = 1 TO NO_OF_MONSTERS
10900     READ MONSTER$(COUNTER)
10910     REPeat CHOOSE_EMPTY
10920       RAN = RND(1 TO NO_OF_ROOMS-1) : REMark RANDOM ROOM NUMBER
10930       IF MAP(RAN,8) = 0 THEN EXIT CHOOSE_EMPTY
10940     END REPeat CHOOSE_EMPTY
10950     MAP(RAN,8) = COUNTER
10960   END FOR COUNTER
10970 END DEFine INITIALISE
10980 :
10990 REMark ********************************************************
11000 REMark * GAME DATA FOLLOWS - TITLE, LIST OF ROOM CONNECTIONS, *
11010 REMark * STARTING ROOM NUMBER, OBJECT DATA, MONSTERS LIST     *
11020 REMark ********************************************************
11030 REMark
11040 REMark ************************************
11050 REMark *   TITLE OF THE ADVENTURE GAME    *
11060 REMark ************************************
11070 DATA "THE QL FORUM ADVENTURE"
11080 :
11090 REMark ************************************
11100 REMark * Currency Unit `, $, Euro etc     *
11110 REMark ************************************
11120 DATA "`"
11130 :
11140 REMark ************************************
11150 REMark * ROOM DATA, FIRST VALUE IS NUMBER *
11160 REMark * NUMBER OF ROOMS, FOLLOWED BY THE *
11170 REMark * START ROOM NUMBER, FOLLOWED BY A *
11180 REMark * LIST OF EXITS  N,S,E,W FROM EACH *
11190 REMark * ROOM (0=NO EXIT,<>0 = LEADS TO A *
11200 REMark * ROOM NUMBER ( <0 = LOCKED DOOR). *
11210 REMark * A FINAL EXIT IS THE HIGHEST ROOM *
11220 REMark * NUMBER.                          *
11230 REMark * IF AN EXIT HAS A NEGATIVE VALUE, *
11240 REMark * IT'S A LOCKED DOOR, AND A KEY IS *
11250 REMark * NEEDED TO UNLOCK IT -  MAKE SURE *
11260 REMark * THAT THE KEY IS IN A ROOM BEFORE *
11270 REMark * A LOCKED DOOR, OR IT WILL NOT BE *
11280 REMark * POSSIBLE TO FIND THE KEY ! ALSO, *
11290 REMark * REMEMBER THAT LOCKED DOORS NEED  *
11300 REMark * -VE NUMBERS FROM BOTH SIDES !    *
11310 REMark * AS SUPPLIED, THE DOOR BETWEEN    *
11320 REMark * ROOMS 3 AND 16 IS LOCKED,AND THE *
11330 REMark * GAME STARTS FROM ROOM 9, ENDS AT *
11340 REMark * HIGHEST ROOM NUMBER.             *
11350 REMark ************************************
11360 DATA 20 : REMark ** NUMBER OF ROOMS
11370 DATA 1  : REMark ** START ROOM NUMBER
11380 DATA 9  : REMark ** NUMBER OF OBJECTS
11390 DATA 8  : REMark ** NUMBER OF MONSTERS
11400 REMark ************************************
11410 REMark * MAP OF ROOMS, TO HELP UNDERSTAND *
11420 REMark * THE MAPPING SYSTEM.  GAME STARTS *
11430 REMark * ROOM 9,ENDS ROOM 16, LOCKED DOOR *
11440 REMark * BETWEEN ROOMS 3 AND 16,  THE KEY *
11450 REMark * IN ROOM 14                       *
11460 REMark *                                  *
11470 REMark * ENTRY-> 01--02  03  04           *
11480 REMark *         |   |   |   |            *
11490 REMark *         05  06--07--08--         *
11500 REMark *         |   |   |   |   |        *
11510 REMark *         09--10  11  12  |        *
11520 REMark *                         |        *
11530 REMark *         13  14--15--16--         *
11540 REMark *         |   |   |                *
11550 REMark *         17--18  19--20 <-EXIT    *
11560 REMark *                                  *
11570 REMark ************************************
11580 DATA 0,5,2,0    : REMark ** ROOM 1
11590 DATA 0,0,0,1    : REMark ** ROOM 2
11600 DATA 0,7,0,0    : REMark ** ROOM 3
11610 DATA 0,8,0,0    : REMark ** ROOM 4
11620 DATA 1,9,0,0    : REMark ** ROOM 5
11630 DATA 0,10,7,0   : REMark ** ROOM 6
11640 DATA 3,11,8,6   : REMark ** ROOM 7
11650 DATA 4,12,16,7  : REMark ** ROOM 8
11660 DATA 5,0,10,0   : REMark ** ROOM 9
11670 DATA 6,0,0,9    : REMark ** ROOM 10
11680 DATA 7,0,0,0    : REMark ** ROOM 11
11690 DATA 8,0,0,0    : REMark ** ROOM 12
11700 DATA 0,17,0,0   : REMark ** ROOM 13
11710 DATA 0,18,15,0  : REMark ** ROOM 14
11720 DATA 0,19,16,14 : REMark ** ROOM 15
11730 DATA 0,0,8,15   : REMark ** ROOM 16
11740 DATA 13,0,18,0  : REMark ** ROOM 17
11750 DATA 14,0,0,17  : REMark ** ROOM 18
11760 DATA 15,0,-20,0 : REMark ** ROOM 19
11770 DATA 0,0,19,0   : REMark ** ROOM 20=EXIT
11780 :
11790 REMark ************************************
11800 REMark * OBJECTS DATA : NAME,VALUE,WEAPON *
11810 REMark ************************************
11820 DATA "Password Book",2,0
11830 DATA "Patio Chair",0,1
11840 DATA "1% Beer",0,1
11850 DATA "Gold Card",567,0
11860 DATA "Super Gold Card",650,0
11870 DATA "Trump Card",357,0
11880 DATA "Qubide",405,0
11890 DATA "Vanpeebles's C5",425,0
11900 DATA "White QL",305,0
11910 :
11920 REMark ************************************
11930 REMark * MONSTER NAMES                    *
11940 REMark ************************************
11950 DATA "vanpeebles"
11960 DATA "Rob Heaton"
11970 DATA "XorA"
11980 DATA "Swenson"
11990 DATA "RWAP"
12000 DATA "Dilwyn"
12010 DATA "Red Dragon"
12020 DATA "Soccer Hooligan"
12030 :
12040 REMark ***************************************************************
12050 REMark * STRING HANDLING FUNCTIONS FOR EASIER CONVERSION TO QL BASIC *
12060 REMark ***************************************************************
12070 :
12080 DEFine FuNction STR$(NUM)
12090   REMark CONVERT NUMERIC VALUE TO STRING
12100   LOCal T$
12110   T$ = NUM
12120   RETurn T$
12130 END DEFine STR$
12140 :
12150 DEFine FuNction LEFT$(S$,NUM)
12160   REMark RETURN 'NUM' CHARACTERS FROM START OF STRING
12170   IF NUM < 1 THEN RETurn ""
12180   IF NUM > LEN(S$) THEN RETurn S$
12190   RETurn S$(1 TO NUM)
12200 END DEFine LEFT$
12210 :
12220 DEFine FuNction MID$(S$,START,NUM)
12230   REMark RETURN 'NUM' CHARACTERS FROM SPECIFIED START POINT IN STRING
12240   IF START < 1 OR START > LEN(S$) THEN RETurn ""
12250   IF NUM < 1 THEN RETurn ""
12260   RETurn S$(START TO START+NUM-1)
12270 END DEFine MID$
12280 :
12290 DEFine FuNction TL$(S$)
12300   LOCal T$,N
12310   REMark STRIP SPACES FROM LEFT OF STRING
12320   T$ = ""
12330   FOR N = 1 TO LEN(S$)
12340     IF S$(N) <> " " THEN T$ = S$(N TO LEN(S$)) : EXIT N
12350   END FOR N
12360   RETurn T$
12370 END DEFine TL$
